Buteo Synchronization Framework: Buteo::OOPClientPlugin Class Reference

Buteo Synchronization Framework

Public Slots | Public Member Functions | List of all members
Buteo::OOPClientPlugin Class Reference
Inheritance diagram for Buteo::OOPClientPlugin:

## Public Slots
virtual void | connectivityStateChanged (Sync::ConnectivityType aType, bool aState)
void | onProcessError (QProcess::ProcessError error)
void | onProcessFinished (int exitCode, QProcess::ExitStatus exitStatus)
void | onError (QString aProfileName, QString aMessage, int aErrorCode)
void | onSuccess (QString aProfileName, QString aMessage)
Public Slots inherited from Buteo::SyncPluginBase
virtual void | connectivityStateChanged (Sync::ConnectivityType aType, bool aState)=0
| Slot that is invoked by sync framework when changes occur in connectivity domains. More...

## Public Member Functions
| OOPClientPlugin (const QString &aPluginName, const Buteo::SyncProfile &aProfile, Buteo::PluginCbInterface *aCbInterface, QProcess &aProcess)
virtual bool | init ()
| Initializes the plugin. More...
virtual bool | uninit ()
| Uninitializes the plugin. More...
virtual bool | startSync ()
| Starts synchronization. More...
virtual void | abortSync (Sync::SyncStatus aStatus=Sync::SYNC_ABORTED)
| Aborts synchronization. More...
virtual Buteo::SyncResults | getSyncResults () const
| Gets the results of the last completed sync session. More...
virtual bool | cleanUp ()
| Cleans up any sync related stuff (e.g sync anchors etc) when the profile is deleted. More...
Public Member Functions inherited from Buteo::ClientPlugin
| ClientPlugin (const QString &aPluginName, const SyncProfile &aProfile, PluginCbInterface *aCbInterface)
| Constructor. More...
virtual | ~ClientPlugin ()
| Destructor. More...
SyncProfile & | profile ()
| access to profile owned and used by this instance
Public Member Functions inherited from Buteo::SyncPluginBase
| SyncPluginBase (const QString &aPluginName, const QString &aProfileName, PluginCbInterface *aCbInterface)
| Constructor. More...
QString | getPluginName () const
| Returns the name of this plugin. More...
QString | getProfileName () const
| Returns profile name. More...

## Additional Inherited Members
Signals inherited from Buteo::SyncPluginBase
void | transferProgress (const QString &aProfileName, Sync::TransferDatabase aDatabase, Sync::TransferType aType, const QString &aMimeType, int aCommittedItems)
| Emitted when progress has been made in synchronization in transferring items between local and remote database. More...
void | error (const QString &aProfileName, const QString &aMessage, SyncResults::MinorCode aErrorCode)
| Emitted when error has occurred in synchronization and it cannot be continued. More...
void | success (const QString &aProfileName, const QString &aMessage)
| Emitted when synchronization has been finished successfully. More...
void | accquiredStorage (const QString &aMimeType)
| Emitted when a storage is requested and accquired. More...
void | syncProgressDetail (const QString &aProfileName, int aProgressDetail)
| Emitted during Sync Progress to indicate the detail of the current ongoing sync. More...
Protected Attributes inherited from Buteo::ClientPlugin
SyncProfile | iProfile
| Sync Profile Object that the plugin is currently operating on.
Protected Attributes inherited from Buteo::SyncPluginBase
PluginCbInterface * | iCbInterface
| Pointer to synchronizer.
QMap< QString, ReceivedItemDetails > | receivedItems
ButeoPluginIface * | iOopPluginIface

## Member Function Documentation

## ◆ abortSync()

void OOPClientPlugin::abortSync | ( | Sync::SyncStatus | aStatus = `Sync::SYNC_ABORTED` | ) |
| virtual

Aborts synchronization.

Derived plug-in should implement this function and abort the sync session that is in progress when this function is called. A final signal (success or error) is still expected from the aborted session before it terminates.

Reimplemented from Buteo::SyncPluginBase.

## ◆ cleanUp()

bool OOPClientPlugin::cleanUp | ( |  | ) |
| virtual

Cleans up any sync related stuff (e.g sync anchors etc) when the profile is deleted.

Derived plug-in should implement this function and perform any cleanup operations if required when the profile is deleted

Implements Buteo::SyncPluginBase.

## ◆ getSyncResults()

SyncResults OOPClientPlugin::getSyncResults | ( |  | ) | const
| virtual

Gets the results of the last completed sync session.

This function should be called only after the sync session has finished, after an error or success signal has been emitted. The default implementation returns empty results, so derived plug-in should implement this function.

Returns
  Sync results.

Reimplemented from Buteo::SyncPluginBase.

## ◆ init()

bool OOPClientPlugin::init | ( |  | ) |
| virtual

Initializes the plugin.

It is recommended that the plugin should do not do any thread insecure initializations inside constructor, instead it should be done inside this method.

Returns
  True on success, otherwise false

Implements Buteo::SyncPluginBase.

## ◆ startSync()

bool OOPClientPlugin::startSync | ( |  | ) |
| virtual

Starts synchronization.

Init must be called before calling this function.

Returns
  True on success, otherwise false

Implements Buteo::ClientPlugin.

## ◆ uninit()

bool OOPClientPlugin::uninit | ( |  | ) |
| virtual

Uninitializes the plugin.

Returns
  True on success, otherwise false

Implements Buteo::SyncPluginBase.

The documentation for this class was generated from the following files:

- OOPClientPlugin.h
- OOPClientPlugin.cpp